#ifndef _CLAERROR_INCL
#define _CLAERROR_INCL

#define D_CLEARERROR            300       // "No Error",
#define D_INVALID_FUNCTION      301       // "INVALID FUNCTION",
#define D_FILE_NOT_FOUND        302       // "FILE NOT FOUND",
#define D_PATH_NOT_FOUND        303       // "PATH NOT FOUND",
#define D_TOO_MANY_OPEN_FILES   304       // "TOO MANY OPEN FILES",
#define D_ACCESS_DENIED         305       // "ACCESS DENIED",
#define D_INVALID_HANDLE        306       // "INVALID HANDLE",
#define D_MEMORY_ARENA_TRASHED  307       // "MEMORY ARENA TRASHED",
#define D_NOT_ENOUGH_MEMORY     308       // "NOT ENOUGH MEMORY",
#define D_INVALID_MEMORY_BLOCK  309       // "INVALID MEMORY BLOCK",
#define D_BAD_ENVIRONMENT       310      // "BAD ENVIRONMENT",
#define D_BAD_FORMAT            311      // "BAD FORMAT",
#define D_INVALID_ACCESS        312      // "INVALID ACCESS",
#define D_INVALID_DATA          313      // "INVALID DATA",
#define D_INVALID_DRIVE         315      // "INVALID DRIVE",
#define D_CURRENT_DIRECTORY     316      // "CURRENT DIRECTORY",
#define D_NOT_SAME_DEVICE       317      // "NOT SAME DEVICE",
#define D_NOMOREFILES           318      // "NO MORE FILES",
#define D_WRITE_PROTECT         319      // "WRITE PROTECT",
#define D_BAD_UNIT              320      // "BAD UNIT",
#define D_NOT_READY             321      // "NOT READY",
#define D_BAD_COMMAND           322      // "BAD COMMAND",
#define D_CRC                   323      // "CRC",
#define D_BAD_LENGTH            324      // "BAD LENGTH",
#define D_SEEK                  325      // "SEEK",
#define D_NOT_DOS_DISK          326      // "NOT DOS DISK",
#define D_SECTOR_NOT_FOUND      327      // "SECTOR NOT FOUND",
#define D_OUT_OF_PAPER          328      // "OUT OF PAPER",
#define D_WRITE_FAULT           329      // "WRITE FAULT",
#define D_READ_FAULT            330      // "READ FAULT",
#define D_GEN_FAILURE           331      // "GEN FAILURE",
#define D_SHARING_VIOLATION     332      // "SHARING VIOLATION",
#define D_LOCK_VIOLATION        333      // "LOCK VIOLATION",
#define D_WRONG_DISK            334      // "WRONG DISK",
#define D_FCB_UNAVAILABLE       335      // "FCB UNAVAILABLE",
#define D_SHARE_BUFFER_EXCEEDED 336      // "SHARING BUFFER EXCEEDED",
#define D_CODE_PAGE_MISMATCHED  337      // "CODE PAGE MISMATCHED",
#define D_HANDLE_EOF            338      // "HANDLE EOF",
#define D_HANDLE_DISK_FULL      339      // "HANDLE DISK FULL",
#define D_NOT_SUPPORTED         350      // "NOT SUPPORTED",
#define D_REM_NOT_LIST          351      // "REM NOT LIST",
#define D_DUP_NAME              352      // "DUP NAME
#define D_BAD_NETPATH           353      // "BAD NETPATH",
#define D_NETWORK_BUSY          354      // "NETWORK BUSY",
#define D_DEV_NOT_EXIST         355      // "DEV NOT EXIST",
#define D_TOO_MANY_CMDS         356      // "TOO MANY CMDS",
#define D_ADAPTER_HARDWARE      357      // "ADAPTER/HARDWARE",
#define D_BAD_NET_RESPONSE      358      // "BAD NET RESPONSE",
#define D_UNEXPECTED_NET_ERROR  359      // "UNEXPECTED NET ERROR",
#define D_BAD_REM_ADAPTER       360      // "BAD REM ADAPTER",
#define D_PRINTQ_FULL           361      // "PRINTQ FULL",
#define D_NO_SPOOL_SPACE        362      // "NO SPOOL SPACE",
#define D_PRINT_CANCELLED       363      // "PRINT CANCELLED",
#define D_NETNAME_DELETED       364      // "NETNAME DELETED",
#define D_NETWORK_ACCESS_DENIED 365      // "NETWORK ACCESS DENIED",
#define D_BAD_DEV_TYPE          366      // "BAD DEV TYPE",
#define D_BAD_NET_NAME          367      // "BAD NET NAME",
#define D_TOO_MANY_NAMES        368      // "TOO MANY NAMES",
#define D_TOO_MANY_SESSIONS     369      // "TOO MANY SESSIONS",
#define D_SHARING_PAUSED        370      // "SHARING PAUSED",
#define D_REQ_NOT_ACCEPTED      371      // "REQ NOT ACCEPTED",
#define D_REDIR_PAUSED          372      // "REDIR PAUSED",
#define D_FILE_EXISTS           380      // "FILE EXISTS",
#define D_DUP_FCB               381      // "DUP FCB",
#define D_CANNOT_MAKE           382      // "CANNOT MAKE",
#define D_FAIL_CRITICAL_ERROR   383      // "FAIL CRITICAL ERROR",
#define D_OUT_OF_STRUCTURES     384      // "OUT OF STRUCTURES",
#define D_ALREADY_ASSIGNED      385      // "ALREADY ASSIGNED",
#define D_INVALID_PASSWORD      386      // "INVALID PASSWORD",
#define D_INVALID_PARAMETER     387      // "INVALID PARAMETER",
#define D_NET_WRITE_FAULT       388      // "NET WRITE FAULT",
#define D_SYS_COMP_NOT_LOADED   390      // "SYS COMP NOT LOADED",
#define D_INVALID_ERR           391      // "Unknown Error"

/**/
/* Clarion Error Code Equates                                                       */
/**/

#define HALTEOJ                 0  // use DOS error when Cla$seterror is called
#define FILNFD                  2
#define PATHNFD                 3
#define TOMNYFLS                4
#define ACCDNID                 5
#define CORRMEM                 7
#define NOMEM                   8

#define ENTNFND                 30          /* "TBL ENTRY NOT FOUND" */
#define FLALLK                  32          /* "FILE IS ALREADY LOCKED" */
#define RECNAV                  33          /* "RECORD NOT AVAILABLE" */
#define NOSREC                  35          /* "RECORD NOT FOUND" */
#define BADDAT                  36          /* "BAD DATA FILE" */
#define FLNTOP                  37          /* "FILE NOT OPEN" */
#define BADINX                  38          /* "BAD KEY FILE" */
#define RECONF                  40          /* "CREATES DUPLICATE KEY" */
#define RCALHD                  43          /* "RECORD IS ALREADY HELD" */
#define BADNAM                  45          /* "INVALID FILENAME" */
#define KEYFLBAD                46          /* "KEY FILE MUST BE REBUILT" */
#define BADDEC                  47          /* "BAD RECORD DECLARATION" */
#define CANTLOG                 48          /* "UNABLE TO LOG TRANSACTION" */
#define FLALOP                  52          /* "FILE ALREADY OPEN" */
#define BADFIL                  53          /* "INVALID CLARION FILE" */
#define NOCRET                  54          /* "CREATE ATTRIBUTE NOT GIVEN" */
#define FNOTSHR                 55          /* "FILE MUST BE SHARED" */
#define LOGACT                  56          /* "LOGOUT ALREADY ACTIVE" */
#define BADMEM                  57          /* "INVALID MEMO FILE" */
#define EXCLREQ                 63          /* "EXCLUSIVE ACCESS REQUIRED" */
#define SHRVIO                  64          /* "SHARING VIOLATION" */
#define CANTROL                 65          /* "UNABLE TO ROLLBACK TRANSACTION" */
#define NOMEMOF                 73          /* "MEMO FILE MISSING" */
#define BADTYPD                 75          /* "BAD FIELD TYPE DESCRIPTOR" */
#define BADDYNI                 76          /* "BAD DYNAMIC INDEX STRING" */
#define DYNNOACC                77          /* "UNABLE TO ACCES DYNAMIC INDEX" */
#define NUMPARM                 78          /* "Invalid number of parameters */
#define BADFDTYP                79          /* "UNSUPPORTED DATA TYPE IN FILE" */
#define NODRVFUNC               80          /* "UNSUPPORTED File Driver Function" */
#define BADERR                  81          /* "UNKOWN ERROR REGISTERED */
#define REPNOTDIM               82          // "USE Must Be Dimensioned For REPEATED Entry"
#define INVSCRN                 83          // "Invalid Screen Structure
#define GRAPH2BIG               84          // "Attempt To Open Graphics Window Larger Than 80x25"
#define INVSCRROW               85          // Invalid ROW In Screen Structure
#define INVSCRCOL               86          // Invalid COL In Screen Structure
#define AREA2BIG                87          // Attempt to SETAREA Larger Than 64K
#define KEY2BIG                 88          // Invalid Key Length
#define RECCHGD                 89          // Record Changed By Another Station
#define FILEERROR               90          // File Driver Error Code
#define NOLOGOUT                91          // No transaction active
#define BUILDACTIVE             92          // Build in Progress
#define BUILDCANCELLED          93          // Build was cancelled by user

/**/
/* DOS Virtual Memory Manager Error Code Equates                                                       */
/**/

#define VM_ERRS                 100
#define R_VMCORRUPT             100  // "Virtual Memory Blocks corrupted.",
#define R_OUTOFHEAP             101  // "No memory to save VM mapping.",
#define R_INVALIDROOM           102  // "Pointer derefernced to invalid location.",
#define R_FAILRECALL            103  // "Could not retrieve a required block.",
#define R_FAILCREATE            104  // "Could not create a new swap unit.",
#define R_FAILFREE              105  // "Could not free a specified swap unit.",
#define R_DEADPOINTER           106  // "Accessing a pointer in bad memory area",
#define H_BOUND_ERR             107  // "Attempt to exceed tracking tables.",
#define H_READFAIL              108  // "Read failure retrieving data.",
#define H_WRITEFAIL             119  // "Write failure saving data.",
#define H_TYPINVALID            110  // "Illegal type for operation.",
#define H_LOCINVALID            111  // "Illegal location for operation.",
#define H_OUTOFCMEM             112  // "Conventional memory exhausted for VM.",
#define M_NOSWAPDEVICE          113  // "No external device allowed for swapping.",
#define M_UNABLESWAPDEVICE      114  // "Swap device currently unavailable.",
#define M_INVALIDMONSTER        115  // "Virtual handle pointing wild.",
#define M_FULLSWAPDEVICE        116  // "Swap device attained maximum capacity.",
#define M_BOUND_ERR             117  // "Attempt exceed tracking tables, increase Meg.",
#define R_HOUSEFULL             118  // "Oversized VM Allocation, Increase Lot Size.",

/**/
/* Expanded Memory Manager Error Code Equates                                                       */
/**/

#define EMS_ERRS                225
#define E_INTERNAL              225  // "Unkown EMS Error",
#define E_BADHARDWARE           226  // "EMS Hardware error",
#define E_BADHANDLE             227  // "Illegal logical EMS reference",
#define E_BADFUNCODE            228  // "Illegal EMS function",
#define E_OUTOFHANDLES          229  // "Too many logical EMS allocations",
#define E_BADSAVECONTEXT        230  // "EMS Context Save/Restore buffer corrupt.",
#define E_NOREALPAGES           231  // "EMS exhausted",
#define E_NOLOGICALPAGES        232  // "Too many logical pages to track internally",
#define E_ZEROPAGES             233  // "Process requested allocation of zero pages",
#define E_NOLOGIC2HANDLE        234  // "Reference to handle with no logical pages allocated",
#define E_BADPHYSPAGE           235  // "Bad physical page reference.",
#define E_MAPAREAFULL           236  // "No space to save mapping.",
#define E_MULTIHANDLEMAPSAVE    237  // "Multiple requests to save EMS mapping on this handle.",
#define E_NOHANDLECONTEXT       238  // "Mapping never saved for this EMS handle.",
#define E_NOSUCHSUBFUNCTION     239  // "Invalid subfunction reference in Get/Set EMS Page Map.",
#define E_VCPI_ERROR            240  // "Virtual Control Program Intfc. Error"

/**/
/* Extended Memory Manager Error Code Equates                                                       */
/**/

#define XMS_ERRS                270
#define X_NOFUNC                270  // "XMS Function Not Implemented"
#define X_VDISKERR              271  // "VDISK device driver detected
#define X_A20                   272  // "A20 Error (Memory Wrap Around)"
#define X_GENERAL               273  // "General XMS Driver Error"
#define X_FATAL                 274  // "Fatal XMS Driver Error
#define X_NOHMA                 275  // "High Memory Not Available"
#define X_HMAMIN                276  // "/HMAMIN=?? Parameter Conflict"
#define X_NOHMAALLOC            277  // "No HMA Allocated"
#define X_A20STILLON            278  // "A20 line still enabled"
#define X_NOMOREXMS             279  // "XMS Exhausted"
#define X_INVALIDHANDLE         280  // "Invalid XMS Handle"
#define X_INVALIDSOURCE         281  // "Invalid XMS Source Handle"
#define X_INVALIDSOFFS          282  // "Invalid XMS Source Offset"
#define X_INVALIDDEST           283  // "Invalid XMS Destination Handle"
#define X_INVALIDDOFFS          284  // "Invalid XMS Destination Offset"
#define X_INVALIDLEN            285  // "Invalid XMS Length"
#define X_INVALIDOVERLAP        286  // "XMS Move Causes Overlap"
#define X_PARITY                287  // "XMS Parity Error Detected"
#define X_NOTLOCKED             288  // "XMS Block Not Locked"
#define X_LOCKDED               289  // "XMS Block Is Locked"
#define X_LOCKCOUNT             290  // "XMS Lock Count Overflowed"
#define X_LOCKFAIL              291  // "XMS Lock Failed"
#define X_SMALLERUMB            292  // "Smaller UMB Is Available"
#define X_NOUMB                 293  // "No UMBs Are Available"
#define X_INVALIDUMB            294  // "Invalid UMB Segment Number"

#endif
