#ifndef _CLAF_INCL
#define _CLAF_INCL
#include <cla.h>

//------------------------------------------------------------------------------
//  Calls to file drivers will be as follows:
//
//  FILE DRIVER FUNCTION NAME (OPCODE, FILE CONTROL BLOCK, ...)
//                                                       /\
//                   Variable argument list  
//------------------------------------------------------------------------------

#ifdef FOPCODES                    // Clarion file system OPCODE identifiers
    #define Cla$ADD               1//     DRV(code,fcb);
    #define Cla$ADDfilelen       51//     DRV(code,fcb,unsigned len);
    #define Cla$APPEND            4//     DRV(code,fcb);
    #define Cla$APPENDlen        59//     DRV(code,fcb);
    #define Cla$BOF               2//     DRV(code,fcb);
    #define Cla$BUFFER           80//     DRV(code,fcb, unsigned buffers);
    #define Cla$BUILDdyn          5//     DRV(code,fcb,key,char *str,int len);
    #define Cla$BUILDdynfilter   34//     DRV(code,fcb,key); + 2 strings Added in CW1.5
    #define Cla$BUILDfile         3//     DRV(code,fcb);
    #define Cla$BUILDkey          6//     DRV(code,fcb,key);
    #define Cla$BYTES            52//     DRV(code,fcb);
    #define Cla$CEOF             14//     DRV(code,fcb);
    #define Cla$CLOSE             7//     DRV(code,fcb);
    #define Cla$COMMITdrv         8//     DRV(code,fcb);
    #define Cla$OPEN             25//     DRV(code,fcb,int mode);
    #define Cla$COPY              9//     DRV(code,fcb,char *str,int len);
    #define Cla$_CREATE          10//     DRV(code,fcb);
    #define Cla$DELETE           11//     DRV(code,fcb);
    #define Cla$DUPLICATE        12//     DRV(code,fcb);
    #define Cla$DUPLICATEkey     57//     DRV(code,fcb,key);
    #define Cla$EMPTY            13//     DRV(code,fcb);
    #define Cla$FLUSH            29//     DRV(code,fcb);
    #define Cla$GETfilekey       15//     DRV(code,fcb,key);
    #define Cla$GETfileptrlen    53//     DRV(code,fcb,long ptr,unsigned len)
    #define Cla$GETfileptr       16//     DRV(code,fcb,long ptr);
    #define Cla$GETkeyptr        17//     DRV(code,fcb,key,long ptr);
    #define Cla$HOLDfile         18//     DRV(code,fcb)
    #define Cla$HOLDfilesec      19//     DRV(code,fcb,int seconds);
    #define Cla$LOCKfile         20//     DRV(code,fcb)
    #define Cla$LOCKfilesec      21//     DRV(code,fcb,int seconds);
    #define Cla$LOGOUTdrv        22//     DRV(code,fcb);
    #define Cla$NAME             23//     DRV(code,fcb);
    #define Cla$NEXT             24//     DRV(code,fcb);
    #define Cla$PACK             26//     DRV(code,fcb);
    #define Cla$POINTERfile      27//     DRV(code,fcb);
    #define Cla$POINTERkey       28//     DRV(code,fcb,key);
    #define Cla$POSITIONfile     61//     DRV(code,fcb);
    #define Cla$POSITIONkey      62//     DRV(code,fcb,key);
    #define Cla$PREV             31//     DRV(code,fcb);
    #define Cla$PUT              30//     DRV(code,fcb);
    #define Cla$PUTfileptr       54//     DRV(code,fcb,long ptr);
    #define Cla$PUTfileptrlen    55//     DRV(code,fcb,long ptr,unsigned l);
    #define Cla$RECORDSfile      32//     DRV(code,fcb);
    #define Cla$RECORDSkey       33//     DRV(code,fcb,key);
    #define Cla$RELEASE          36//     DRV(code,fcb);
    #define Cla$REMOVE           37//     DRV(code,fcb);
    #define Cla$RENAME           38//     DRV(code,fcb,char *str,int len);
    #define Cla$RESETfile        63//     DRV(code,fcb,char *str);
    #define Cla$RESETkey         64//     DRV(code,fcb,key,char *str);
    #define Cla$ROLLBACKdrv      40//     DRV(code,fcb);
    #define Cla$SEND             60//     DRV(code,fcb,char *str,int len);
    #define Cla$SETfile          41//     DRV(code,fcb);
    #define Cla$SETfilekey       42//     DRV(code,fcb,key);
    #define Cla$SETfileptr       43//     DRV(code,fcb,long ptr);
    #define Cla$SETkey           44//     DRV(code,fcb,key);
    #define Cla$SETkeykeyptr     47//     DRV(code,fcb,key,key,long ptr);
    #define Cla$SETkeykey        45//     DRV(code,fcb,key,key);
    #define Cla$SETkeyptr        46//     DRV(code,fcb,key,long ptr);
    #define Cla$SHARE            48//     DRV(code,fcb,int mode);
    #define Cla$SKIP             49//     DRV(code,fcb,long num);
    #define Cla$STREAM           56//     DRV(code,fcb);
    #define Cla$UNLOCK           50//     DRV(code,fcb);

    #define Cla$WATCH            58//     DRV(code,fcb);
    #define Cla$NOMEMO           65//     DRV(code,fcb);
    #define Cla$REGETfile        66//     DRV(code,fcb,char *str)
    #define Cla$REGETkey         67//     DRV(code,fcb,char *str)
    #define Cla$NULL             68//     DRV(code,fcb,void * field)
    #define Cla$SETNULL          69//     DRV(code,fcb,void * field)
    #define Cla$SETNONNULL       70//     DRV(code,fcb,void * field)
    #define Cla$SET_PROPERTY     71//     DRV(code,fcb)
    #define Cla$GET_PROPERTY     72//     DRV(code,fcb)
    #define Cla$QUERY_KEY        73//     DRV(code,fcb)
    #define Cla$QUERY_VIEW       74//     DRV(code)
    #define Cla$_BLOB_YIELD      75//     DRV(code,fcb,unsigned short, unsigned long, unsigned long)
    #define Cla$_BLOB_TAKE       76//     DRV(code,fcb,unsigned short, unsigned long, unsigned long)
    #define Cla$_BLOB_SIZE       77//     DRV(code,fcb,unsigned short)
    #define Cla$_BLOB_SETPROPERTY 78//    DRV(code,fcb,unsigned short)
    #define Cla$_BLOB_GETPROPERTY 79//    DRV(code,fcb,unsigned short)

    #define Cla$SETviewfields    81//     DRV(code,vcb,long fields)
    #define Cla$CLEARfile        82//     DRV(code,fcb)
    #define Cla$RESETviewf       83//     DRV(code,vcb,fcb)
    #define Cla$START_BUILD      84//     DRV(code,fcb)
    #define Cla$KEY_SETPROPERTY  85//     DRV(code,fcb,key)
    #define Cla$KEY_GETPROPERTY  86//     DRV(code,fcb,key)
    #define Cla$REGISTER         87// Internal used to start buffer
    #define Cla$DO_PROPERTY      88//     DRV(code,fcb)
    #define Cla$KEY_DOPROPERTY   89//     DRV(code,fcb,key,ndx)
    #define Cla$BLOB_DOPROPERTY  90//     DRV(code,fcb,memo)
    #define Cla$WHO_ARE_YOU      91// Internal used in buffering code
    #define Cla$BULK_READ_ON     92// Used by View Engine
    #define Cla$BULK_READ_OFF    93//  "   "   "    "

// The following define is used to set up utility internal tables
// regarding driver functionality within clarion (accounting for expansion)
    #define Cla$TOTFOPCODES      94

// above high water mark is 64 for the language opcodes
//--OPCODES over 100 are special opcodes for use outside the language
//  #define CREATE_NK       100     // Create file without keys
//  #define CREATE_K        101     // Create keys for a file that has no keys
#endif


//--Sharing mode and Access mode defines for OPEN and SHARE---------------------
#define     READOLY     0           // Access Mode read only
#define     WRITOLY     1           // Access Mode write only
#define     READWRIT    2           // Access Mode read/write

#define     DENY_RW     0x10        // Sharing mode deny read/write
#define     DENY_W      0x20        // Sharing mode deny write
#define     DENY_R      0x30        // Sharing mode deny read
#define     DENY_NONE   0x40        // Sharing mode deny none

// The following define is used to set up utility internal tables
// regarding driver functionality within clarion (accounting for expansion)

#define Cla$TOTDATATYPES        25


//******************************************************************************
// The following structure is setup by each driver and the address of this
// structure is passed back to the administrator for scanning files
//******************************************************************************

// If this structure changes, then update the Clarion equivalent in
// SYNMISC.INC

typedef struct {
    char raw_name[21];              // raw driver name
    char dll_name[13];              // driver dll name
    char copywrite[41];             // copywrite for driver
    char desc[31];                  // description for driver
    Cla_PIPE_FUNC driver;
    union {
        unsigned long attrval;      // bit field structure value
        struct {
            unsigned create     :1; // supports create attribute
            unsigned owner      :1; // owner attribute ?
            unsigned encrypt    :1; // data encryption ?
            unsigned reclaim    :1; // reclaim attribute ?
            unsigned keys       :1; // keys supported ?
            unsigned kseq       :2; // key component sequenceing(asc/dsc)
            unsigned kunique    :1; // key unique key supported ?
            unsigned kcase      :1; // key case sensative support ?
            unsigned kxnulls    :1; // key exclude nulls supported ?
            unsigned indeces    :1; // indeces supported ?
            unsigned iseq       :2; // index component sequenceing(asc/dsc)
            unsigned icase      :1; // index case sensative support ?
            unsigned ixnulls    :1; // index exclude nulls supported ?
            unsigned dynind     :1; // dynamic indeces supported ?
            unsigned dseq       :2; // dyn index component sequenceing(asc/dsc)
            unsigned dcase      :1; // dyn index case sensative support ?
            unsigned dxnulls    :1; // dyn index exclude nulls supported ?
            unsigned memos      :1; // memos supported ?
            unsigned memobin    :1; // memos binary supported ?
            unsigned sql        :1; // SQL file driver?
            unsigned oem        :1; // ANSI to OEM support
            unsigned logalias   :1; // logout file and alias?
            unsigned            :7; //  filler out to 32 - FYI
            char     reserved0;     // Compatibility with CW 1000-1001
        }drvattr;
    }u;
    unsigned short clastrlen;       // if supported, max clarion string length
    unsigned short cstrlen;         // max cstring length
    unsigned short reclen;          // total record length - 64K max
    unsigned long  clastrlen32;     // if supported, max clarion string length for 32bit apps
    unsigned long  cstrlen32;       // max cstring length for 32bit apps
    unsigned long  reclen32;        // total record length for 32bit apps
    unsigned char maxdims;          // total number of dimensions
    unsigned char maxkeys;          // total keys and indeces - 255 max
    unsigned char maxmemos;         // total memos - 255 max
    unsigned short memosize;        // maximum memo size
    unsigned long  memosize32;      // maximum memo size for 32bit apps
// PSW -- Sizes of Driver Kit structures to allow processing outside
//        the Driver (e.g. the Meta Driver)
    unsigned fldsize;               // size of the Drv_FLD structure
    unsigned kcbsize;               // size of the Drv_KCB structure
    unsigned mcbsize;               // size of the Drv_MCB structure
    unsigned fcbsize;               // size of the Drv_FCB structure
    char reserved1[12];             // reserved allowing for sizes
// PSW
//  char reserved1[20];             // reserved
    unsigned char *tdesc;           // pointer to type descriptor for
                                    // functions and data types supported
}DRVREG;

// The following defines are for key, index, and dynamic index sequencing

#define ASC         0   // ascending only
#define ASCDSC      1   // ascending/descending. mixed
#define ASCDSC1     2   // ascending/descending. All components must be the same

#endif
