#ifndef _CLASTST_
#define _CLASTST_
#include <clacomp.hpp>
#ifdef __cplusplus
extern "C" {
#endif
#pragma save,name(prefix=>""),call(seg_name => clareng)


/*-----------------11-24-93 10:02am-----------------
 These two structure definitions are **private**
 Do NOT make assumptions based upon them
 --------------------------------------------------*/
struct ClassDescriptor;

struct Ufo;

typedef Ufo *UFO;

#ifdef __32BIT__
typedef Ufo *UFOs;
#else
typedef Ufo near *UFOs;  // SS relative
#endif

/*-----------------12-06-93 11:29am-----------------
 Miscelaneous stuff that is probably useless to all but the compiler
 --------------------------------------------------*/

unsigned    Cla$Omitted(unsigned, unsigned, ... );

/*-----------------22/09/95 16:10-------------------
 Clearing routines
 --------------------------------------------------*/
void Cla$ClearType( void *, char, int );
void Cla$ClearDec( void *, unsigned, char, int );
void Cla$CLEAR(char *data, char *tdesc, int value);

/*-----------------01-15-97 02:47pm-----------------
 NEW support routines
 --------------------------------------------------*/
void * Cla$NewMemZ ( unsigned );  // malloc and zero
void * Cla$NewMemB ( unsigned );  // malloc and blank
void * Cla$NewMemT ( unsigned, void * );    // malloc and use typedesc

/*-----------------09-02-93 09:21am-----------------
 Prototypes for the Clarion string accumulator
 --------------------------------------------------*/

void        Cla$PopTemp(StrDescP s);
void        Cla$PullTemp(StrDescP s);
void        Cla$clearstr(void *, unsigned);
void        *Cla$SaveStack(void);
void        Cla$PopCString(char *s,unsigned len);
void        Cla$PopPString(char *s,unsigned len);
long        Cla$PopPictLong(char *s);
double      Cla$PopPictReal(char *s);
double      Cla$PopReal(void);
long        Cla$PopLong(void);
void        Cla$PopString(char *s,unsigned len);
void        Cla$PushCString(const char *s);
void        Cla$PushLong(long l);
void        Cla$PushNull(void);
void        Cla$PushBool(int b);
void        Cla$PushPictDec(const char *p);
void        Cla$PushPictLong(long l,const char *p);
void        Cla$PushPictReal(double r,const char *p);
void        Cla$PushReal(double r);
void        Cla$PushString(const char *s,unsigned len);
void        Cla$PushTemp(char *s,unsigned len);
void        Cla$RestoreStack(void *saved);
void        Cla$Stack2DStack();
void        Cla$StackAGE(long l1,long l2);
void        Cla$StackALL(unsigned len);
void        Cla$StackCENTER(unsigned len);
void        Cla$StackCLIP(void);
int         Cla$StackCompare(void);
int         Cla$StackCompareI(void);
int         Cla$StackCompareN(void);
int         Cla$StackCompareR(void);
int         Cla$StackCompareS(void);
void        Cla$StackConcat(void);
void        Cla$StackConcatR(void);
#ifdef _WIN
void        Cla$StackCONTENTS(int u);
#else
void        Cla$StackCONTENTS(unsigned u);
#endif
void        Cla$StackDEFORMAT(const char *s);
void        Cla$StackDEFORMAT2(void);
void        Cla$StackErrstr(void);
void        Cla$StackFORMAT(const char *s);
void        Cla$StackFORMAT2(void);
int         Cla$StackINLIST(unsigned char n);
unsigned    Cla$StackINSTRING(unsigned step,unsigned start);
void        Cla$StackHeap(void);
void        Cla$StackLEFT(unsigned len);
unsigned    Cla$StackLen(void);
unsigned    Cla$StackLen2(void);
void        Cla$StackLOWER(void);
void        Cla$STACKpop(void);    // Pop top of stack
unsigned    Cla$StackNUMERIC(void);
void        Cla$StackPRESS(void);
void        Cla$StackPRINTstr(void);
void        Cla$StackReadSv(char *scr,char *des, unsigned dlen, unsigned num);
double      Cla$STACKreal(void); // View top of stack as real
void        Cla$StackRIGHT(unsigned len);
void        Cla$StackSetSv(char *scr,char *des, unsigned dlen, unsigned num);
void        Cla$StackSHOW(unsigned u1,unsigned u2);
void        Cla$StackSUB(unsigned pos,unsigned len);
#ifdef _WIN
#pragma save,call(seg_name=>WSLMETA)
void Cla$StackTYPE(void);
#pragma restore
#else
void        Cla$StackTYPE(void);
#endif
unsigned char Cla$StackVAL(void);
void        Cla$StackUPPER(void);

/*-----------------09-02-93 09:20am-----------------
   Prototypes for dynamic and variant typed parameters
   Library should now use Class interface where possible
 --------------------------------------------------*/
void *      Cla$AddressUfo(UFO u);
UFO         Cla$Array2Ufo(void *m,unsigned t,unsigned v,unsigned v2,unsigned n);
UFO         Cla$ArrayOfUfo(UFO r, unsigned n);
void        Cla$AssignLong2RefUfo( UFO &d, long b );
void        Cla$AssignLong2Ufo( UFO d, long b );
void        Cla$AssignReal2RefUfo( UFO &d, double b );
void        Cla$AssignReal2Ufo( UFO d, double b );
void        Cla$AssignRefUfo( UFO &d, UFO s );
void        Cla$AssignStr2Ufo ( UFO d );
void        Cla$AssignUfo( UFO d, UFO s );
void        Cla$BindG( UFO g );
void        Cla$ClearUfo(UFO u, int value);
UFO         Cla$CloneUfo(UFO u, unsigned value);
void        Cla$DPopUfo( UFO u );
void        Cla$DPushUfo( UFO u );
UFO         Cla$DStack2Ufo(void);
void        Cla$DeepAssign(UFO t, UFO f, void *in);
UFO         Cla$DesignateUfo(UFO u,unsigned t);
void        Cla$FreeUfo( UFO u );
void        Cla$FreeUpUfo( UFO u );
UFO         Cla$Group2Ufo(void *,char *);
int         Cla$IsUfoString(UFO u);
UFO         Cla$Long2Ufo(long);
UFO         Cla$Mem2Ufo(void *m,unsigned char t,unsigned info,unsigned size, char copy);
UFO         Cla$Picture2Ufo(void *m,const void *p,char copy);
UFO         Cla$PictureUfo(const void *p);
void        Cla$PushUfo(UFO u);
UFO         Cla$Real2Ufo(double d);
void        Cla$RefAssignAny(UFO *l,UFO r);
UFO         Cla$SelectUfo(UFO u, unsigned);
UFO         Cla$SelectUfo2(UFO u, unsigned, unsigned);
unsigned    Cla$SizeUfo(UFO u);
UFO         Cla$Stack2Ufo(void);
void        Cla$Stack2UfoC(UFO u);
void        Cla$StackRotate(unsigned char n);
int         Cla$TypeSize( char );
long        Cla$Ufo2Long( UFO u );
double      Cla$Ufo2Real( UFO u );
int         Cla$UfoCompareN( UFO d );
int         Cla$UfoRealDiff ( UFO d, double s );
unsigned    Cla$UfoType(UFO u);
int         Cla$Ufodistinct( UFO d, UFO s );
int         Cla$Ufodistincti( UFO d, UFO s );

#pragma restore
#ifdef __cplusplus
}
#endif
#include "claufo.hpp"

#endif
