/* Release 0.01a*/
/*
 ***************************************************************************
 *                                                                         *
 *      convutil.h   - Definitions for mixed language numeric conversion   *
 *                                                                         *
 *      Copyright(C) 1992-92 Clarion Software Corporation.                 *
 *                                                                         *
 *      LastMod 28 Sep 92 GH                                               *
 *      Created 15 Sep 92 GH                                               *
 *                                                                         *
 ***************************************************************************/

#ifndef _CONVUTIL_H
#define _CONVUTIL_H

#ifdef __cplusplus
extern "C" {
#endif

#define RSFlag_UpperCaseE          1
#define RSFlag_AlwaysSignReal      2
#define RSFlag_AlwaysAddPoint      4
#define RSFlag_LeaveSignSpace      8
#define RSFlag_StripTrailZero     16
#define RSFlag_LeftJustify        32
#define RSFlag_PadWithZeros       64

#define SRFlag_NeedDigitPrePoint   1
#define SRFlag_NeedDigitPostPoint  2
#define SRFlag_NeedDecPoint        4
#define SRFlag_ErrorIfInvalid      8
#define SRFlag_Lowercase_E_OK      16
#define SRFlag_FailOnUnderflow     32

typedef enum _RealNumberType
           { NormalNumber, NotANumber, PlusInfinity, MinusInfinity }
                                                     RealNumberType;

#define MaxMantissaChars        18
#define MantCharsPerLoop        9
#define MantLoopFactor          1E9L

/*
 * Change this if necessary
 */
typedef short  RealExpType;

extern RealNumberType _GetNumberType(LDouble    Value);

extern void _SetSpecialStr(
             RealNumberType    NumberType,
             BYTE_ptr          DestStr,
             size_t            DestLen,
             size_t *          NumChars);

extern MaxCard _StrToVal(
                BYTE_ptr SourceStr,
                size_t   SourceLen,
                unsigned Base,
                ssize_t* CharsDone);

extern size_t  _ValToStr(
                MaxCard  Value,
                BYTE_ptr DestStr,
                size_t   DestMax,
                unsigned Base,
                unsigned MinDigits,
                char     HexBase);

extern LDouble _Reduce_Number(
             LDouble          Value,
             RealExpType *    Exponent);

extern LDouble _GetPowerOf10(RealExpType Exponent);
extern LDouble _MultPowerOf10(LDouble Result,  RealExpType Exponent);

extern void _BuildMantissaStr(
                LDouble      Mantissa,
                size_t       CharsToGo,
                char *       MantissaStr);

extern size_t  _ConvertMantissa(
                BYTE_ptr        SourceStr,
                size_t          SourceLen,
                Cardinal        FormatInfo,
                LDouble *       Mantissa,
                long *          Exponent,
                ssize_t *       PreDotPlaces);

extern ssize_t _GetExponent(
                BYTE_ptr        SourceStr,
                size_t          SourceLen,
                BOOL            NumberIsZero,
                long *          Exponent);

#ifdef __cplusplus
}
#endif

#endif
