/*
 ***************************************************************************
 *                                                                         *
 *      define.h    - Standard definitions for portable types.             *
 *                                                                         *
 *      Copyright(C) 1992-92 Clarion Software Corporation.                 *
 *                                                                         *
 *      LastMod 23 Nov 92 GH                                               *
 *      Created  7 Sep 92 GH                                               *
 *                                                                         *
 ***************************************************************************/


#ifndef DEFINE_H
#define DEFINE_H
#ifdef _WIN
#include <windows.h>
#else

#define TRUE 1
#define FALSE 0

#ifndef __OS2DEF__
typedef unsigned char   BOOL;
typedef unsigned char   BYTE;
#endif
#endif

typedef BYTE *          BYTE_ptr;

#ifdef  __32BIT__
typedef void *          void_far_ptr;
typedef void *          void_near_ptr;
typedef void *          void_ptr;
#else
typedef void far *      void_far_ptr;
typedef void near *     void_near_ptr;
typedef void *          void_ptr;
#endif

typedef signed long     SStrIdx;
typedef unsigned long   MaxCard;
typedef unsigned short  Cardinal;

typedef long double     LDouble;

/*
 * Compare the addresses that the two pointers point at.
 */
#ifdef __32BIT__
#define PTRcmp(ptr1, op, ptr2)          ptr1 op ptr2
#else
#if _WIN
#define PTRcmp(ptr1, op, ptr2)          ptr1 op ptr2
#else

#define Normalise(ptr)                                         \
         (((((unsigned long) ptr) & 0xffff0000) >> 12) +       \
                     (((unsigned long) ptr) & 0xffff))

#define PTRcmp(ptr1, op, ptr2)                                  \
        (Normalise(ptr1) op Normalise(ptr2))
#endif
#endif


/* Floating point constants */
#define MaxValidExp         +308
#define MinValidExp         -330
#define MaxRealMant         1.7
#define MinRealMant         2.33

#define MaxRealValue        1.7E+308

#if defined(__32BIT__) || defined(_HUGE)
#define _SIZET_MAX          ULONG_MAX
#define _SSIZET_MAX         LONG_MAX
#else
#define _SIZET_MAX          USHRT_MAX
#define _SSIZET_MAX         SHRT_MAX
#endif

#endif
