#include <clwclib.h>

/* Flag values for open  */

#define O_RDONLY	     0
#define O_WRONLY	     1
#define O_RDWR		     2

#define O_CREAT		0x0100	/* create and open file */
#define O_TRUNC		0x0200	/* open with truncation */
#define O_EXCL		0x0400	/* exclusive open */

#define _O_EOF		0x0200 /* set when text file hits ^Z   */

/* A file in append mode may be written to only at its end. */

#define O_APPEND	0x0800	/* to end of file */

/* File mode special bits. User may only read these bits */

#define O_CHANGED	0x1000	/* File has been written */
#define O_DEVICE	0x2000	/* user read only flag	 */
#define O_TEXT		0x4000	/* CR-LF translation	*/
#define O_BINARY	0x8000	/* no translation	*/

/* DOS 3.x file sharing options */

#define SH_NOINHERIT	 0x80
#define SH_COMPAT	 0x00
#define SH_DENYRW	 0x10
#define SH_DENYWR	 0x20
#define SH_DENYRD	 0x30
#define SH_DENYNO	 0x40

#define SH_DENYNONE	SH_DENYNO     /* MS documentation uses both */

#define S_IFMT  0170000  /* file type mask */
#define S_IFDIR  0x4000  /* directory */
#define S_IFCHR  0x2000  /* character device */
#define S_IFREG  0x8000  /* regular file */
#define S_IREAD  0x0100  /* owner may read */
#define S_IWRITE 0x0080  /* owner may write */
#define S_IEXEC  0x0040  /* owner may execute <directory search> */

#ifdef __cplusplus
extern "C" {
#endif




#include <define.h>

int open(const char *path, int flags, ...);
int sopen(const char *path, int access,int shflag, ...);
int _open(const char *Path, int Access);
int _create(const char * Path, int access, int permission);
int lock(int, long Ofs, long Len);
int unlock( int,long,long );
int chsize(int handle, long newsize);
ssize_t read(int CurHandle, void * ptr, size_t NumBytes);
ssize_t write(int CurHandle, const void * ptr, size_t NumBytes);
long lseek(int CurHandle, long offset, int whence);
long tell(int CurHandle);
int close(int CurHandle);
long filelength(int handle);

#ifdef __cplusplus
}
#endif

#define strcmpi(s1,s2)		stricmp(s1,s2)
#define strncmpi(s1,s2,n)	strnicmp(s1,s2,n)

