/* Release 0.01a*/
/*
 ***************************************************************************
 *                                                                         *
 *      mixconv.h   - Definitions for mixed language numeric conversion    *
 *                                                                         *
 *      Copyright(C) 1992-92 Clarion Software Corporation.                 *
 *                                                                         *
 *      LastMod 27 Oct 92 GH                                               *
 *      Created  9 Sep 92 GH                                               *
 *                                                                         *
 ***************************************************************************/

#ifndef MIXCONV_H
#define MIXCONV_H

#ifdef __cplusplus
extern "C" {
#endif

typedef enum {
    CExpFormat, PasExpFormat, ModExpFormat,
    CFixedFormat, PasFixedFormat, ModFixedFormat,
    ModEngFormat, CChooseFormat } FltFmt;

/* Args to _StrToInt, _StrToCard */
#define    Skip_0x_Prefix             1
#define    Disallow_Neg_Card          2

extern size_t  _CardToStr(
                MaxCard  Value,
                BYTE_ptr DestStr,
                size_t   DestMax,
                unsigned Base,
                char     HexBase);

extern size_t  _IntToStr(
                long     Value,
                BYTE_ptr DestStr,
                size_t   DestMax,
                unsigned Base,
                char     HexBase,
                BOOL     AlwaysSign);

extern size_t  _RealToStr(
             LDouble    value,
             BYTE_ptr   DestStr,
             size_t     DestLen,
             FltFmt     Format,
             size_t     Precision,
             size_t     FieldWidth,
             int        MinExpChars,
             unsigned   FormatInfo);

extern size_t _RealToFile(
             LDouble    value,
             STREAM     DestFile,
             FltFmt     Format,
             size_t     Precision,
             size_t     FieldWidth,
             int        MinExpChars,
             unsigned   FormatInfo);

extern void _CvtReal(
             LDouble    Value,
             BYTE_ptr   DestStr,
             size_t     DestLen,
             FltFmt     Format,
             size_t     Precision,
             int *      DecPoint,
             int *      sign);


extern long _StrToInt(
                BYTE_ptr SourceStr,
                size_t   SourceLen,
                unsigned Base,
          unsigned short ConvInfo,
                ssize_t* CharsDone);

extern unsigned long _StrToCard(
                BYTE_ptr SourceStr,
                size_t   SourceLen,
                unsigned Base,
          unsigned short ConvInfo,
                ssize_t* CharsDone);

extern ssize_t _StrToReal(
                BYTE_ptr        SourceStr,
                size_t          SourceLen,
                unsigned        FormatInfo,
                LDouble *       Result);

#ifdef __cplusplus
}
#endif

#endif

