#define SQLVER "00"
#include <claver.h>

/*****************************************************************************
 *
 * History
 *
 * 09 Dec 97  00   . Set to release version
 * 03 Nov 97  25   . Fixed Fat Fetches to work on a order change followed
 *                   by a RESET(view,position).
 *                 . Changed REMOVE to do DROP filename, rather than
 *                   DROP tablename
 *                 -------- Version sent to US ----------
 * 28 Aug 97  24   . Fixed data corruption in views where fields that needed
 *                   conversion after fetch where not converted out of the
 *                   buffered data
 *                 -------- Version sent to US ----------
 * 18 Aug 97  23   . Fixed GPF in buffering code when file has a group
 *                   or OVER field
 * 22 Jul 97  22   . Added PROP:FetchSize
 *                 -------- Version sent to NUS and US ----------
 * 30 Jun 97  21   . Added Asynchronous reads
 * 23 Jun 97  20   . Fixed bug where RESET(view);NEXT(view) would return
 *                   the current record buffer rather than the real buffer
 * 19 Jun 97       . Added bulk reads
 * 14 Jun 97  19   . Fixed GPF when using views in singely linked EXEs
 *  8 Jun 97       . Fixed bug where PROP:SQL on a view was binding all
 *                   key components
 *  1 Apr 97  18   . Fixed bug where PUT was not working if the only change
 *                   was to change NULL status on a field.
 *                 . Fixed bug where the hold flag was not cleared by GET
 * 17 Dec 96  17   . Fixed bug where SETting on a non-unique key on a view
 *                   can skip records
 * 08 Dec 96  16   . Fixed bug where if a field that is over another is
 *                   projected, then the base field was not automatically
 *                   projected.
 * 29 Nov 96  15   . Made SET(View,n) where n > 0 work
 * 22 Nov 96  14   . Fixed bug where changing PROP:Where does not recompile
 *                   SELECT statement
 * 15 Nov 96  13   . Fixed bug where PROP:Order on fields in multiple tables
 *                   could not be reset on
 * 12 Nov 96  12   . Fixed bug where delete cursor was not being closed and
 *                   update cursor not closed for drivers without CURRENT
 * 11 Nov 96  11   . Fixed bug where RESET(view)/NEXT was not stuffing the
 *                   the right buffer if reseting on the same record.
 * 08 Nov 96  10   . Fixed lots of bugs in using PROP:Order in a view
 * 07 Nov 96  09   . Fixed bug where kit was clearing NULL timestamps to
 *                   spaces rather than zeros.
 * 03 Nov 96  08   . Fixed bug where /USEPRIMARY was only applied to the
 *                   main file of a view.  So if the joining key was not the
 *                   primary key is was possible to generate a non-unique
 *                   ORDER BY
 * 01 Nov 96  07   . Fixed heap corruption when SEND /WHERE is used twice on
 *                   the same file
 *                 . Added clean up code so safe memory leaks are cleaned up
 *                   when in debug mode
 * 31 Oct 96  06   . Added POSITION(file) and REGET(file)
 * 30 Oct 96  05   . Fixed OEM support so it only adds function for OEM files
 *                   and not all files
 * 26 Oct 96  04   . Fixed bug where RESET(key) was not working if resetting
 *                   on a duplicate key component and the first record
 *                   retrieved did not match the primary key component
 *                 . Fixed bug where scrollable cursors did not reset
 *                   properly on the last record after an EOF
 * 26 Oct 96  03   . Added OEM support
 * 21 Oct 96  02   . Added char * return for sqlParseStr
 *                 . Added basicAdd
 * 11 Oct 96  01   . Created SQLVER.H
 *  9 Oct 96       . Fixed bug where PROP:SQL would GPF if
 *                   the file had a timestamp structure in it
 *
 *****************************************************************************/
