/*----------------------------------------------------------------
 * WSL.H - public interface to WSL
 * Copyright (C) 1993 Clarion Software Corporation
 * All rights reserved
 *----------------------------------------------------------------*/

#ifndef WSL_INCL
#define WSL_INCL
#include <ClaStSt.h>
#ifdef __cplusplus
extern "C" {
#endif

#pragma save, name(prefix=>"")

#ifndef __32BIT__
extern unsigned screenpool;
#define SCREENPOOL <screenpool>
#else
#define SCREENPOOL
#endif

#ifdef __cplusplus
 class reportscreen;
 class screen;
 typedef screen SCREENPOOL *PSCREEN;
 typedef reportscreen SCREENPOOL *PREPSCREEN;
#else
 typedef struct screen SCREENPOOL *PSCREEN;
 typedef struct reportscreen SCREENPOOL *PREPSCREEN;
#endif

#ifndef _THREADPROC
#define _THREADPROC
typedef void (*THREADPROC)(void);
#endif

typedef void (*ASSERTPROC)(unsigned line);


int   Cla$ACCEPTED();
void  Cla$ALERT(int key1, int key2);
void  Cla$ALIAS(UINT from=0, UINT to=0);
void  Cla$ARC(int x, int y, int w, int h, int start, int end);
void  Cla$ASK();
void  Cla$BLANK(int x, unsigned char nox, int y, unsigned char noy, int w, unsigned char now, int h, unsigned char noh);
void  Cla$BOX(int x, int y, int w, int h, COLORREF fillcolor);
void  Cla$CHANGE(int feq  /* , string nval */);
int   Cla$CHOICE(int feq);
void  Cla$CHORD(int x, int y, int w, int h, int start, int end, COLORREF fillcolor);
void  Cla$CLIPBOARD(int format);  /* : string*/
void  Cla$CLOSEwindow(PREPSCREEN pw);
typedef BOOL (*COLORDIALOGPROC)(unsigned char /*<string>*/, UFO color, int mode);
BOOL  Cla$COLORDIALOG(unsigned char /*<string>*/, UFO color, int mode=0);
int   Cla$CREATE(int feq, int type, int parentfeq, int position);
void  Cla$DESTROY(int feq1, int feq2);
void  Cla$DISABLE(int feq1, int feq2);
void  Cla$DISPLAY(int feq1, int feq2);
void  Cla$DRAGID(UFO hostthread, UFO hostfeq);
void  Cla$DROPID(UFO targetthread, UFO targetfeq);
void  Cla$ELLIPSE(int x, int y, int w, int h, COLORREF fillcolor);
void  Cla$ENABLE(int feq1, int feq2);
void  Cla$ENDPAGE(PREPSCREEN pr, BOOL pageonly = FALSE);
void  Cla$ERASE(int feq1, int feq2);
int   Cla$EVENT();
int   Cla$FIELD();
const char *Cla$FIELDNAME(int feq);   /* Used by debugger */
typedef BOOL (*FILEDIALOGPROC)(unsigned char /*<string>*/, UFO filename, unsigned char /*<string>*/, int mode=0);
BOOL  Cla$FILEDIALOG(unsigned char /*<string>*/, UFO filename, unsigned char /*<string>*/, int mode=0);
int   Cla$FIRSTFIELD();
int   Cla$FOCUS();
typedef BOOL (*FONTDIALOGPROC)(unsigned char /*<string>*/, UFO fontname, UFO size, UFO color, UFO style, int);
BOOL  Cla$FONTDIALOG(unsigned char /*<string>*/, UFO fontname, UFO size, UFO color, UFO style, int);
void  Cla$GETFONT(int feq, UFO fontname, UFO size, UFO color, UFO style);
void  Cla$GETPOSITION(int feq, UFO x, UFO y, UFO w, UFO h);
void  Cla$GETINI(/*string, string,*/ unsigned char /*<string>*/, unsigned char /*<string>*/); /* : string */
typedef void (*HALTPROC)(UINT retcode, unsigned char nomessage /* <STRING> message*/);
void  Cla$HALT(UINT retcode, unsigned char nomessage /* <STRING> message*/);
void  Cla$HELP(unsigned char, unsigned char/* <STRING>, <STRING> */);
void  Cla$HIDE(int feq1, int feq2);
void  Cla$IDLE(THREADPROC idle, UINT idletime);
void  Cla$IMAGE(int x, int y, int w, int h /*, string filename */);
int   Cla$INCOMPLETE();
UINT  Cla$KEYBOARD();
UINT  Cla$KEYCHAR();
UINT  Cla$KEYCODE();
UINT  Cla$KEYSTATE();
int   Cla$LASTFIELD();
void  Cla$LINE(int x, int y, int w, int h);
void  Cla$LOCKTHREAD();
int   Cla$MOUSEX();
int   Cla$MOUSEY();
void  Cla$OPENowned(PREPSCREEN pw, PREPSCREEN owner);
void  Cla$OPENwindow(PREPSCREEN pw);
void  Cla$PIE(int x, int y, int w, int h, unsigned int deltacount, unsigned int *deltas,
             unsigned int colorcount, COLORREF *colors, int depth, unsigned int wholevalue,
             int startangle);
LONG  Cla$PENCOLOR();
int   Cla$PENSTYLE();
int   Cla$PENWIDTH();
void  Cla$POLYGON(int, int *, COLORREF fillcolor);
int   Cla$POPUP(/*string,*/ int xpos, int ypos);
void  Cla$POST(UINT eventno, int feq=0, int thread=0, int atfront=0);
void  Cla$PRESSKEY(unsigned keycode);
void  Cla$PRESSstring(char *string, unsigned len);
void  Cla$PRINTdetail(PREPSCREEN pr, UINT detailno);
void  Cla$PRINTreport(PREPSCREEN pr, int detailfeq);
typedef BOOL (*PRINTERDIALOGPROC)(unsigned char, /*<string>,*/ BOOL);
BOOL  Cla$PRINTERDIALOG(unsigned char, /*<string>,*/ BOOL);
void  Cla$PUTINI(/*string, string, string,*/ unsigned char /*entopt*/, unsigned char /*valopt*/, unsigned char /*optstring*/);
void  Cla$REGISTEREVENT(int eventno, long proc, long lval, PREPSCREEN pw, int feq, unsigned char nofeq);
int   Cla$REJECTCODE();
void  Cla$ROUNDBOX(int x, int y, int w, int h, COLORREF fillcolor);
void  Cla$SELECT(int feq1, UINT index1, UINT index2);
int   Cla$SELECTED();
void  Cla$SET3DLOOK(UINT);
void  Cla$SETCLIPBOARD(/*string*/);
void  Cla$SETCURSOR(unsigned char none/*, string on string stack*/);
void  Cla$SETDROPID(/* signature  on string stack */);
void  Cla$SETFONT(int feq, unsigned char /*<string>*/, int, COLORREF, UINT);
void  Cla$SETKEYCODE(UINT);
void  Cla$SETKEYCHAR(UINT);
void  Cla$SETPENCOLOR(COLORREF);
void  Cla$SETPENSTYLE(int);
void  Cla$SETPENWIDTH(int);
void  Cla$SETPOSITION(int feq, int x, int y, int w, int h);
void  Cla$SETTARGET(PREPSCREEN pw, int thread=0);
void  Cla$SHOW(int x, int y /*,string*/);
int   Cla$START(THREADPROC a, UINT stacksize=0);
int   Cla$START1(THREADPROC a, UINT stacksize=0);
int   Cla$START2(THREADPROC a, UINT stacksize=0);
int   Cla$START3(THREADPROC a, UINT stacksize=0);
typedef void (*STOPPROC)(unsigned char /*<STRING>*/);
void  Cla$STOP(unsigned char /*<STRING>*/);
int   Cla$THREAD();
BOOL  Cla$THREADLOCKED();
void  Cla$UNHIDE(int feq1, int feq2);
void  Cla$UNLOCKTHREAD();
void  Cla$UNREGISTEREVENT(int eventno, long proc, long lval, unsigned char noval, PREPSCREEN pw, int feq, unsigned char nofeq);
void  Cla$UPDATE(int feq1, int feq2);
void  Cla$YIELD();

void  Cla$code();
void  Cla$DoProp(int feq, UINT ps);    /* property on string stack */
UINT  Cla$EndEventLoops(int leave);    /* in wsllow.a */
void  Cla$freewindow(PREPSCREEN pw);
void  Cla$GetPropS(int feq, int index, UINT ps);
void  Cla$init();
void  Cla$paopen(PSCREEN *ahand, const char *module, const char *dname, ...);
void  Cla$pmopen(PSCREEN *mhand, const char *module, const char *dname, ...);
void  Cla$propen(PREPSCREEN *rhand, const char *module, const char *dname, ...);
void  Cla$pwopen(PSCREEN *whand, const char *module, const char *dname, ...);
void  Cla$RegisterSwapS(void *data, size_t size);
void  Cla$RegisterSwapL(void *data, size_t size);
void  Cla$RegisterSwapQS(void *data);
void  Cla$RegisterSwapQL(void *data);
void  Cla$RegisterSwapF(void *fcb);
void  Cla$UnRegisterSwapF(void *fcb);
void  Cla$SetPropF(int feq, void * qcb, int Field, int index, UINT ps);
void  Cla$SetPropQ(int feq, void * qcb, int index, UINT ps);
void  Cla$SetPropS(int feq, int index, UINT ps);
void  Cla$SetPropV(int feq, void * ufo, int index, UINT ps);

/*--------------------------------------------------------------------------
 * DDE support for Clarion for Windows
 *--------------------------------------------------------------------------*/

/* Public interface */
typedef unsigned long PCONV;

void Cla$DDEquery(unsigned char, unsigned char);           // <STRING>,<STRING>)
unsigned long Cla$DDEclient(unsigned char, unsigned char); // <STRING>,<STRING>
unsigned long Cla$DDEserver(unsigned char, unsigned char); // <STRING>,<STRING>
void Cla$DDEread(PCONV, UINT, UFO);                        // ULONG,SHORT,STRING,<*?>
void Cla$DDEwrite(PCONV, UINT, UFO);                       // ULONG,SHORT,STRING,<*?>
void Cla$DDEpoke(PCONV); /* two strings on stack */        // ULONG,STRING,STRING
void Cla$DDEexecute(PCONV); /* string on stack */          // ULONG,STRING
void Cla$DDEclose(PCONV);                                  // ULONG

PCONV Cla$DDEchannel();        // (),ULONG
void  Cla$DDEitem();           // (),STRING
void  Cla$DDEapp();            // (),STRING
void  Cla$DDEtopic();          // (),STRING
void  Cla$DDEvalue();          // (),STRING
void  Cla$DDEacknowledge(int); // (SIGNED)

UINT Wsl$SetInternalFlags(UINT val);
HWND Wsl$GetActiveWindow();
UINT Wsl$EndEventLoops(int leave);
int  Wsl$DoEvent(UINT eventno, BOOL SaveErrorState = FALSE);

#define IF_SMALLTOOLBOXCAPTION       0x01
#define IF_MSGBOX_NONBOLD            0x02
#define IF_AUTO                      0x04
#define IF_ENDSESSIONTITLE           0x08
#define IF_FLATBUTTONSDEFAULT        0x10


#pragma save
#ifdef __32BIT__
#pragma call(alloca=>on,reg_saved=>(st1,st2))
#endif
BOOL  Cla$StartEventLoop(void);
BOOL  Cla$EndEventLoop(int endcode);
#pragma restore

extern HINSTANCE Wsl@AppInstance;      /* Application (EXE) instance        */
extern BOOL      Wsl@CloseDownAborted; /* MDI children refused to close     */
extern BOOL      Wsl@LFNEnabled;       /* Should use long filenames if possible if TRUE */

void Wsl$Closedown(void);
void Wsl$FatalError(int, const char *);
PREPSCREEN Wsl$GetTargetWindow();

/* Event numbers */

#define EVENT_FIRST       (WM_USER+0x1000)

/* Field-action events (ACCEPTED() returns field number) */

#define EVENT_ACCEPTED     (EVENT_FIRST+0x01)
#define EVENT_NEWSELECTION (EVENT_FIRST+0x02)
#define EVENT_SCROLLUP     (EVENT_FIRST+0x03)
#define EVENT_SCROLLDOWN   (EVENT_FIRST+0x04)
#define EVENT_PAGEUP       (EVENT_FIRST+0x05)
#define EVENT_PAGEDOWN     (EVENT_FIRST+0x06)
#define EVENT_SCROLLTOP    (EVENT_FIRST+0x07)
#define EVENT_SCROLLBOTTOM (EVENT_FIRST+0x08)
#define EVENT_LOCATE       (EVENT_FIRST+0x09)

#define EVENT_MOUSEDOWN    (EVENT_ACCEPTED)
#define EVENT_MOUSEUP      (EVENT_FIRST+0x0a)
#define EVENT_MOUSEIN      (EVENT_FIRST+0x0b)
#define EVENT_MOUSEOUT     (EVENT_FIRST+0x0c)
#define EVENT_MOUSEMOVE    (EVENT_FIRST+0x0d)
#define EVENT_VBXEVENT     (EVENT_FIRST+0x0e)
#define EVENT_ALERTKEY     (EVENT_FIRST+0x0f)
#define EVENT_PREALERT     (EVENT_FIRST+0x10)
#define EVENT_DRAGGING     (EVENT_FIRST+0x11)
#define EVENT_DRAG         (EVENT_FIRST+0x12)
#define EVENT_DROP         (EVENT_FIRST+0x13)
#define EVENT_SCROLLDRAG   (EVENT_FIRST+0x14)
#define EVENT_TABCHANGING  (EVENT_FIRST+0x15)
#define EVENT_EXPANDING    (EVENT_FIRST+0x16)
#define EVENT_CONTRACTING  (EVENT_FIRST+0x17)
#define EVENT_EXPANDED     (EVENT_FIRST+0x18)
#define EVENT_CONTRACTED   (EVENT_FIRST+0x19)
#define EVENT_REJECTED     (EVENT_FIRST+0x1A)
#define EVENT_DROPPINGDOWN (EVENT_FIRST+0x1B)
#define EVENT_DROPPEDDOWN  (EVENT_FIRST+0x1C)
#define EVENT_SCROLLTRACK  (EVENT_FIRST+0x1D)
#define EVENT_COLUMNRESIZE (EVENT_FIRST+0x1E)

/* Field-selection events (SELECTED() returns field number) */

#define EVENT_SELECTED    (EVENT_FIRST+0x101)

/* Field-independent events (ACCEPTED()/SELECTED() return 0) */

#define EVENT_ANONFIRST   (EVENT_FIRST+0x200)
#define EVENT_CLOSEWINDOW (EVENT_FIRST+0x201)
#define EVENT_CLOSEDOWN   (EVENT_FIRST+0x202)
#define EVENT_OPENWINDOW  (EVENT_FIRST+0x203)
#define EVENT_OPENFAILED  (EVENT_FIRST+0x204)
#define EVENT_LOSEFOCUS   (EVENT_FIRST+0x205)
#define EVENT_GAINFOCUS   (EVENT_FIRST+0x206)

#define EVENT_SUSPEND     (EVENT_FIRST+0x208)
#define EVENT_RESUME      (EVENT_FIRST+0x209)
#define EVENT_NOTIFY      (EVENT_FIRST+0x20A)
#define EVENT_TIMER       (EVENT_FIRST+0x20B)

#define EVENT_DDEFIRST    (EVENT_FIRST+0x20C)
#define EVENT_DDEREQUEST  (EVENT_FIRST+0x20C)
#define EVENT_DDEADVISE   (EVENT_FIRST+0x20D)
#define EVENT_DDEDATA     (EVENT_FIRST+0x20E)
#define EVENT_DDEEXECUTE  (EVENT_FIRST+0x20F)
#define EVENT_DDEPOKE     (EVENT_FIRST+0x210)
#define EVENT_DDECLOSED   (EVENT_FIRST+0x211)
#define EVENT_DDELAST     (EVENT_FIRST+0x211)

#define EVENT_MOVE        (EVENT_FIRST+0x220)
#define EVENT_SIZE        (EVENT_FIRST+0x221)
#define EVENT_RESTORE     (EVENT_FIRST+0x222)
#define EVENT_MAXIMIZE    (EVENT_FIRST+0x223)
#define EVENT_ICONIZE     (EVENT_FIRST+0x224)
#define EVENT_COMPLETED   (EVENT_FIRST+0x225)
#define EVENT_MOVED       (EVENT_FIRST+0x230)
#define EVENT_SIZED       (EVENT_FIRST+0x231)
#define EVENT_RESTORED    (EVENT_FIRST+0x232)
#define EVENT_MAXIMIZED   (EVENT_FIRST+0x233)
#define EVENT_ICONIZED    (EVENT_FIRST+0x234)

#define EVENT_BUILDFILE   (EVENT_FIRST+0x240)
#define EVENT_BUILDKEY    (EVENT_FIRST+0x241)
#define EVENT_BUILDDONE   (EVENT_FIRST+0x242)

#define EVENT_USER        (EVENT_FIRST+0x400)
#define EVENT_LAST        (EVENT_FIRST+0x0fff)

#define QUERY_COLOR       (EVENT_FIRST+0x100c)

/* EVENT_REJECTED reasons */
#define REJECTED_RANGE    1
#define REJECTED_BLANK    2
#define REJECTED_INVALID  3

/* Event loop responses */
#define LOOPBREAK  -1
#define LOOPFALL   0
#define LOOPCYCLE  1

/* Font style constants */
#define FONT_WEIGHT      0x07ff
#define FONT_FIXED       0x0800
#define FONT_ITALIC      0x1000
#define FONT_UNDERLINE   0x2000
#define FONT_STRIKEOUT   0x4000

#define FIELDBASE       0x4000

// For the benefit of old applets ...

#define Cla$MESSAGE Cla$EVENT

#pragma restore
#ifdef __cplusplus
}
#endif

#endif //WSL_INCL

