#ifndef WSLDEBUG_INCL
#define WSLDEBUG_INCL

#ifdef __cplusplus
extern "C" {
#endif

#pragma save, name(prefix=>"")

void WslDebug$NameMessage(char *s, unsigned mno);
void WslDebug$Diagnostic(const char *s,...);
void WslDebug$DumpMessage(const char *s, HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam);
void WslDebug$DumpMetaRecord(METARECORD *lpmr);
void WslDebug$AssertFailed(const char *assertion, const char *file, long int line);
void WslDebug$print(/* string on string stack */);
void WslDebug$printhex(UINT hexval);
void WslDebug$printline();
void WslDebug$printevent();

#pragma restore

#if _RELEASE
#define assert(ignore)  ((void) 0)
#define trace(ignore)
#else
#define assert(p)	((p) ? ((void) 0) : (( (void) WslDebug$AssertFailed(\
                          #p, __FILE__, __LINE__))))
#define trace(p)        WslDebug$Diagnostic(p)
#endif

#ifdef __cplusplus
// MsgTrace class automatically traces messages on entry/exit to procedure
class MsgTrace
{
  private:
    static tracelevel;
    HWND hWnd;
    UINT msg;
    WPARAM wParam;
    LPARAM lParam;
    const char *text;
  public:
    MsgTrace(const char *, HWND, UINT, WPARAM, LPARAM);
    ~MsgTrace();
};

}
#endif

#endif // WSLDEBUG_INCL
